<?php
/*
 * PHP page to get all the action request...
 * @Author: Suraj Roy
 * @Date  :   30 August 2016
 * @Source: https://jsonworld.com
 * @Topic : CRUD with Angularjs, PHP & mysql.
 */        

include 'connect.php';
$db = new DATABASE();
$tblName = 'books';
if(isset($_REQUEST['type']) && !empty($_REQUEST['type'])){ 
    $type = $_REQUEST['type'];
    switch($type){
        case "view":
            $records = $db->getRows($tblName);  
            if($records){
                $resp['records'] = $db->getRows($tblName);
                $resp['status'] = 'OK';
            }else{
                $resp['records'] = array();
                $resp['status'] = 'ERR';
            }
            echo json_encode($resp);
            break;
        case "add":
            if(!empty($_POST['data'])){
                $userData = array(
                    'book_id' => $_POST['data']['book_id'],
                    'book_name' => $_POST['data']['book_name'],
                    'author' => $_POST['data']['author']
                );                
                $book_id  = $_POST['data']['book_id']  ? $_POST['data']['book_id'] : '';
                $book_name = $_POST['data']['book_name'] ? $_POST['data']['book_name'] : '';
                $author = $_POST['data']['author'] ? $_POST['data']['author'] : '';
                
                $res = $db->add_book($book_id,$book_name,$author);
                if($res){
                    $d = array(
                        "id"=> $res,
                        "book_id" => $book_id,
                        "book_name" => $book_name,
                        "author" => $author
                    );
                    $resp['data'] = $d;
                    $resp['status'] = 'OK';
                    $resp['msg'] = 'Book has been added successfully.';
                }else{
                    $resp['status'] = 'ERR';
                    $resp['msg'] = 'Some problem occurred, please try again.';
                }
            }else{
                $resp['status'] = 'ERR';
                $resp['msg'] = 'Some problem occurred, please try again.';
            }
            echo json_encode($resp);
            break;
        case "edit":
            if(!empty($_POST['data'])){
                $update = $db->update($_POST['data']['book_id'],$_POST['data']['book_name'],$_POST['data']['author'],$_POST['data']['id']);
                if($update){
                    $resp['status'] = 'OK';
                    $resp['msg'] = 'Book data has been updated successfully.';
                }else{
                    $resp['status'] = 'ERR';
                    $resp['msg'] = 'Some problem occurred, please try again.';
                }
            }else{
                $resp['status'] = 'ERR';
                $resp['msg'] = 'Some problem occurred, please try again.';
            }
            echo json_encode($resp);
            break;
        case "delete":
            if(!empty($_POST['id'])){
                $id = $_POST['id'];

                $delete = $db->delete($id);
                if($delete){
                    $resp['status'] = 'OK';
                    $resp['msg'] = 'Book data has been deleted successfully.';
                }else{
                    $resp['status'] = 'ERR';
                    $resp['msg'] = 'Something went wrong.';
                }
            }else{
                $resp['status'] = 'ERR';
                $resp['msg'] = 'Something went wrong.';
            }
            echo json_encode($resp);
            break;
        default:
            echo '{"status":"INVALID"}';
    }
}
